--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 10.1
--  \   \         Application : ISE
--  /   /         Filename : ALU1bit_MSB_testwf.vhw
-- /___/   /\     Timestamp : Thu Nov 13 16:42:50 2008
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: ALU1bit_MSB_testwf
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY ALU1bit_MSB_testwf IS
END ALU1bit_MSB_testwf;

ARCHITECTURE testbench_arch OF ALU1bit_MSB_testwf IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT ALU1bit_MSB
        PORT (
            ALU1bit_MSB_a : In std_logic;
            ALU1bit_MSB_b : In std_logic;
            ALU1bit_MSB_less : In std_logic;
            ALU1bit_MSB_opcode0 : In std_logic;
            ALU1bit_MSB_opcode1 : In std_logic;
            ALU1bit_MSB_binvert : In std_logic;
            ALU1bit_MSB_carryin : In std_logic;
            ALU1bit_MSB_result : Out std_logic;
            ALU1bit_MSB_carryout : Out std_logic;
            ALU1bit_MSB_overflow : Out std_logic
        );
    END COMPONENT;

    SIGNAL ALU1bit_MSB_a : std_logic := '0';
    SIGNAL ALU1bit_MSB_b : std_logic := '0';
    SIGNAL ALU1bit_MSB_less : std_logic := '0';
    SIGNAL ALU1bit_MSB_opcode0 : std_logic := '0';
    SIGNAL ALU1bit_MSB_opcode1 : std_logic := '0';
    SIGNAL ALU1bit_MSB_binvert : std_logic := '0';
    SIGNAL ALU1bit_MSB_carryin : std_logic := '0';
    SIGNAL ALU1bit_MSB_result : std_logic := '0';
    SIGNAL ALU1bit_MSB_carryout : std_logic := '0';
    SIGNAL ALU1bit_MSB_overflow : std_logic := '0';

    BEGIN
        UUT : ALU1bit_MSB
        PORT MAP (
            ALU1bit_MSB_a => ALU1bit_MSB_a,
            ALU1bit_MSB_b => ALU1bit_MSB_b,
            ALU1bit_MSB_less => ALU1bit_MSB_less,
            ALU1bit_MSB_opcode0 => ALU1bit_MSB_opcode0,
            ALU1bit_MSB_opcode1 => ALU1bit_MSB_opcode1,
            ALU1bit_MSB_binvert => ALU1bit_MSB_binvert,
            ALU1bit_MSB_carryin => ALU1bit_MSB_carryin,
            ALU1bit_MSB_result => ALU1bit_MSB_result,
            ALU1bit_MSB_carryout => ALU1bit_MSB_carryout,
            ALU1bit_MSB_overflow => ALU1bit_MSB_overflow
        );

        PROCESS
            BEGIN
                -- -------------  Current Time:  100ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_b <= '1';
                ALU1bit_MSB_less <= '1';
                ALU1bit_MSB_opcode1 <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  200ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_a <= '1';
                ALU1bit_MSB_b <= '0';
                ALU1bit_MSB_less <= '0';
                ALU1bit_MSB_opcode0 <= '1';
                ALU1bit_MSB_opcode1 <= '0';
                ALU1bit_MSB_carryin <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  300ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_b <= '1';
                ALU1bit_MSB_less <= '1';
                ALU1bit_MSB_opcode0 <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  400ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_a <= '0';
                ALU1bit_MSB_b <= '0';
                ALU1bit_MSB_binvert <= '1';
                ALU1bit_MSB_carryin <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  500ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_opcode0 <= '1';
                ALU1bit_MSB_opcode1 <= '1';
                ALU1bit_MSB_binvert <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  600ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_a <= '1';
                ALU1bit_MSB_b <= '1';
                ALU1bit_MSB_opcode1 <= '0';
                ALU1bit_MSB_carryin <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  700ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_less <= '0';
                ALU1bit_MSB_opcode0 <= '0';
                ALU1bit_MSB_opcode1 <= '1';
                ALU1bit_MSB_binvert <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  800ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_a <= '0';
                ALU1bit_MSB_b <= '0';
                ALU1bit_MSB_less <= '1';
                ALU1bit_MSB_opcode0 <= '1';
                ALU1bit_MSB_carryin <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  900ns
                WAIT FOR 100 ns;
                ALU1bit_MSB_b <= '1';
                ALU1bit_MSB_less <= '0';
                ALU1bit_MSB_opcode1 <= '0';
                ALU1bit_MSB_carryin <= '1';
                -- -------------------------------------
                WAIT FOR 100 ns;

            END PROCESS;

    END testbench_arch;

